#define	AWATTHR		0x01
#define	BWATTHR		0x02
#define	CWATTHR		0x03
#define	AVARHR		0x04
#define	BVARHR		0x05
#define	CVARHR		0x06
#define	AVAHR		0x07
#define	BVAHR		0x08
#define	CVAHR		0x09
#define	AIRMS		0x0A
#define	BIRMS		0x0B
#define	CIRMS		0x0C
#define	AVRMS		0x0D
#define	BVRMS		0x0E
#define	CVRMS		0x0F
#define	FREQ		0x10
#define	WFORM		0x12
#define	OPMODE		0x13
#define	MMODE		0x14
#define	WAVMODE		0x15
#define	COMPMODE	0x16
#define	LCYCMODE	0x17
#define	MASK		0x18
#define	STATUS		0x19
#define	RSTATUS		0x1A
#define	SAGCYC		0x1D
#define	SAGLVL		0x1E
#define	VPINTLVL	0x1F
#define	GAIN		0x23
#define	AVRMSGAIN	0x24
#define	BVRMSGAIN	0x25
#define	CVRMSGAIN	0x26
#define	AIGAIN		0x27
#define	BIGAIN		0x28
#define	CIGAIN		0x29
#define	AVRMSOS		0x33
#define	BVRMSOS		0x34
#define	CVRMSOS		0x35
#define	AIRMSOS		0x36
#define	BIRMSOS		0x37
#define	CIRMSOS		0x38

//	****************************

void leerADE(unsigned char command, unsigned int nChars, unsigned char *res);
void escribirADE(unsigned char command, unsigned int nChars, unsigned char *res);

unsigned long hex2dec(unsigned long val);
void long2char(unsigned long s, unsigned char *t);
void long2charCompleta(unsigned long s, unsigned char *t);

//	****************************

void escribirADE(unsigned char command, unsigned int nChars, unsigned char *res)
{
	unsigned int i;
	byte dummy;
	byte error;

	SS_ClrVal();
	
	for(i=0;i<100;i++){}
	error = SM1_RecvChar(&dummy);

	command |= 0x80;
	error = SM1_SendChar(command);
	
	for(i=0;i<1000;i++){}
	error = SM1_RecvChar(&dummy);

	while(nChars--)
	{
		error = SM1_SendChar(*res);
		res++;

		for(i=0;i<500;i++){}
		error = SM1_RecvChar(&dummy);
	}

	SS_SetVal();

	for(i=0;i<2000;i++){}
}

void leerADE(unsigned char command, unsigned int nChars, unsigned char *res)
{
	unsigned int i;
	byte dummy;
	byte error;

	SS_ClrVal();
	
	for(i=0;i<100;i++){}
	error = SM1_RecvChar(&dummy);

	error = SM1_SendChar(command);
	
	for(i=0;i<2000;i++){}
	error = SM1_RecvChar(&dummy);

	while(nChars--)
	{
		error = SM1_SendChar(0);

		for(i=0;i<500;i++){}
		error = SM1_RecvChar(res++);
	}

	SS_SetVal();

	for(i=0;i<2000;i++){}
}

unsigned long hex2dec(unsigned long val)
{
	unsigned long res;
	
	res = 0;
	
	res |= (val / 10000) * 65536;
	val %= 10000;
	res |= (val / 1000) * 4096;
	val %= 1000;
	res |= (val / 100) * 256;
	val %= 100;
	res |= (val / 10) * 16;
	res |= val % 10;
	
	return(res);
}

void long2char(unsigned long s, unsigned char *t)
{
	t[0] = (unsigned char)(s >> 16) & 0xFF;
	t[1] = (unsigned char)(s >> 8) & 0xFF;
	t[2] = (unsigned char)(s >> 0) & 0xFF;
	//t[3] = (unsigned char)(s >> 0) & 0xFF;
}

void long2charCompleta(unsigned long s, unsigned char *t)
{
	t[0] = (unsigned char)(s >> 24) & 0xFF;
	t[1] = (unsigned char)(s >> 16) & 0xFF;
	t[2] = (unsigned char)(s >> 8) & 0xFF;
	t[3] = (unsigned char)(s >> 0) & 0xFF;
}
