void lcdSendDec32(unsigned long value);
void lcdSendDec32Short(unsigned long value, unsigned int nums);
void mostrarLCD(int mostrarFase);

//	***********************

void lcdSendDec32(unsigned long value)
{
	unsigned long res;
	unsigned int i, j;
	unsigned char n;
	
	res = 0;
	
	res |= (value / 10000) * 65536;
	value %= 10000;
	res |= (value / 1000) * 4096;
	value %= 1000;
	res |= (value / 100) * 256;
	value %= 100;
	res |= (value / 10) * 16;
	res |= value % 10;
	
	j = 24;
	for(i=0;i<6;i++)
	{
		j -= 4;
		n = (unsigned char)(res >> j) & 0x0F;
		lcdSendChr('0' + n);
	}
}

void lcdSendDec32Short(unsigned long value, unsigned int nums)
{
	unsigned long res;
	unsigned int i, j;
	unsigned char n;
	
	res = 0;
	
	res |= (value / 100000) * 16777216;
	value %= 100000;
	res |= (value / 10000) * 65536;
	value %= 10000;
	res |= (value / 1000) * 4096;
	value %= 1000;
	res |= (value / 100) * 256;
	value %= 100;
	res |= (value / 10) * 16;
	res |= value % 10;
	
	if(nums == 6)
		j = 24;
	if(nums == 5)
		j = 20;
	if(nums == 4)
		j = 16;
	if(nums == 3)
		j = 12;
	if(nums == 2)
		j = 8;
	if(nums == 1)
		j = 4;

	for(i=0;i<nums;i++)
	{
		j -= 4;
		n = (unsigned char)(res >> j) & 0x0F;
		lcdSendChr('0' + n);
	}
}

void mostrarLCD(int mostrarFase)
{
	lcdSend(LCD_1L, LCD_CMD);
	lcdSendStr("Fase ");
	lcdSendChr('A' + (unsigned int)mostrarFase);
	lcdSendChr(':');
}

